#include<menuet/os.h>
#include "vgavblank.h"
#include "../../driver.h"
#include "kolibri.h"

#define FPS
#define SOUND
#ifdef SOUND
	//#include "sound.h"
	#include "soundMine.h"
	static int soundvol=100;
	static int soundq=0;
	static int GCount=0;
#endif	

static char * Title="FCEU\0";
static char FileNES[150]="/hd0/2/";
static char KeyMap[128];

static char BaseDirectory[2048]; //extern byte BaseDirectory[2048];
static unsigned char WinSizeX=2,WinSizeY=2;
int winwidth=265, winheight=295;

extern int GameLoaded;

static int inited=0;
int eoptions=0;
static int gametype;
#ifdef FRAMESKIP
	int frameskip=0;
#endif

int UpdateKeyboard(void);
char *GetKeyboard(void);
void InitMouse();
int InitVideo();
void KillVideo();
void KillKeyboard(){} //Stub
uint32 GetJSOr(){ } //Stub
void SilenceSound(int s) {s=0;} //Stub

void GetMouseData(uint32 *MouseData)
{
	uint16 x,y;
	uint32 z;
	z=__kolibri__getmousedata(&x, &y);
	MouseData[0]=(x-5)/WinSizeX;
	MouseData[1]=(y-40)/WinSizeY;
	MouseData[2]=z;
}

#include "input.c"

static void ParseGI(FCEUGI *gi)
{
 gametype=gi->type;

 InputType[0]=UsrInputType[0];
 InputType[1]=UsrInputType[1];
 InputTypeFC=UsrInputTypeFC;

 if(gi->input[0]>=0)
  InputType[0]=gi->input[0];
 if(gi->input[1]>=0)
  InputType[1]=gi->input[1];
 if(gi->inputfc>=0)
  InputTypeFC=gi->inputfc;
		char ast[25]="";
		sprintf(ast,"it[0]=%d it[1]=%d\n\n\r",InputType[0],InputType[1]);
		FCEUD_Message(ast);
 //FCEUI_GetCurrentVidSystem(&srendline,&erendline);
}

int DoGameLoad(char *path)
{
	FCEUGI *tmp;
	FCEUI_CloseGame();
    if(!(tmp=FCEUI_LoadGame(path)))	 return 0;
    ParseGI(tmp);
    //RefreshThrottleFPS();  
	return 1;
}

int StartGame(char *path)
{
	char Error[50]="";
	if(DoGameLoad(FileNES)) 
	{
		if(!InitVideo()) return 0;
		else
		//if(DriverInitialize())
		{
			InitOtherInput();
			FCEUI_Emulate();
		}
		DriverKill();
		FCEUI_Kill();
	}
	else 
	{
		sprintf(Error,"Can't load file: %s",FileNES);
		FCEUD_PrintError(Error);
		return 0;
	}
	return 1;
}

void ProcessEvent(int event);

char * LoadNESFile()
{
	int i=0,j=0;
	for(;;)
	{
		__menuet__bar(5,25,winwidth-10,15,0);
		__menuet__write_text(10,30,0xFFFFFF,FileNES,strlen(FileNES));
		for(;;)
		{	i =__menuet__wait_for_event();
			if (i==2) break;
			ProcessEvent(i);
		}
		j=__menuet__getkey();
		if (j==1) return FileNES; //Esc
		if (j==28) //Enter
		{ 
			StartGame(FileNES);
			return FileNES;
		}		
		//__kolibri__getasciimap(KeyMap);		
		if (j==15 || j==29 || j==42) continue; //Tab || Left_Control || Left_Shift
		if (j==14) FileNES[strlen(FileNES)-1]='\0'; //BackSpace
		if ((j>1 && j<54 && j!=14) || j==57)
		{
			FileNES[strlen(FileNES)]=KeyMap[j];
			FileNES[strlen(FileNES)+1]='\0';
		}
	}
}

void SetWinSize()
{
	char tmp[10]="";
	int winx=1,i=0,j=0;
	__menuet__bar(5,20,winwidth-10,20,0);
	__menuet__write_text(5,30,0xFFFFFF,"WinSizeX : ",12);
	__menuet__write_text(100,30,0xFFFFFF,"WinSizeY : ",12);
	for(;;)
	{
		for(;;)
		{	i =__menuet__wait_for_event();
			if (i==2) break;
			ProcessEvent(i);
		}
		j=__menuet__getkey();
		if (j==1) break; //Esc
		if (j==28) //Enter
		{
			if (winx) {WinSizeX=atoi(tmp); winx=0; tmp[0]='\0';}
			else {WinSizeY=atoi(tmp); break;}
		}
		
		if (j==14) tmp[strlen(tmp)-1]='\0'; //BackSpace
		if (j>1&&j<12 && strlen(tmp)<5) 
		{
			tmp[strlen(tmp)]=KeyMap[j];
			tmp[strlen(tmp)+1]='\0';
		}
		if (winx)
		{
			__menuet__bar(70,20,30,20,0);
			__menuet__write_text(70,30,0xFFFFFF,tmp,strlen(tmp));
		}
		else
		{
			__menuet__bar(167,20,30,20,0);
			__menuet__write_text(167,30,0xFFFFFF,tmp,strlen(tmp));
		}
	}
	__kolibri__winresize(256*WinSizeX+8, 240*WinSizeY+55);
}

// Video interface 
static unsigned char *ScreenLoc;
static unsigned char keybuf[256]="";

static int PaletteChanged=0;
static unsigned char paldbr[256],paldbg[256],paldbb[256];

void FCEUD_GetPalette(unsigned char index, unsigned char *r, unsigned char *g, unsigned char *b) // +
{
 *r=paldbr[index];
 *g=paldbg[index];
 *b=paldbb[index];
 PaletteChanged=1;
}

void FCEUD_SetPalette(unsigned char index, unsigned char r, unsigned char g, unsigned char b) // +
{
  paldbr[index]=r;
  paldbg[index]=g;
  paldbb[index]=b;
}

int vretrace=1;
int ssync=0;
int dowait=1;

void WaitForVBlank(void) // + 
{
	if(dowait)
	{
		if(ssync)
		{
		  wackyer:
			if (vretrace) vretrace--;
			else goto wackyer;
		}
		else if(!ssync)
			WaitVBlank();
	}
}

int InitVideo()
{
	ScreenLoc=(char *)malloc(256*256);
	if (!ScreenLoc) return 0;
	return 1;
}

void KillVideo()
{
	if (ScreenLoc) free (ScreenLoc);
}


void paint(void) // +
{
	__menuet__window_redraw(1);
	winwidth=256*WinSizeX+8;
	winheight=240*WinSizeY+55;
	__menuet__define_window(100,100,winwidth,winheight,0x03000000,0x800000FF,0x000080);
	//__menuet__bar(5,40,winwidth-10,winheight-55,0);
	__kolibri__draw_title(Title);
	__menuet__window_redraw(2);
}

void ProcessEvent(int event)
{
	switch(event)
	{
		case 1:
			paint();
		break;
		/*case 2:
			__menuet__getkey();
		break;*/
		case 3:	
			if(__menuet__get_button_id()==1) 
			{
				//DriverInterface(DES_EXIT,0);
				DriverKill();
				__menuet__sys_exit();
			}
		break;
	}
}

void UpdateFCEUWindow() // +
{
	int	i =__menuet__check_for_event();
	ProcessEvent(i);
	//FCEUI_DispMessage("UpdateFCEUWindow() called\0");
	//FCEUD_Message("UpdateFCEUWindow() called\0");
}

#ifdef SOUND
void WriteSoundDSP(uint32 * Buffer)
{
  //memcpy(Buf,Buffer,200);
//  int i;
//  for (i=0;i<256;i++) Buf[i]=Buffer[i];
  int P,c;
  int32 *src=Buffer;
  int16 *dest=Buffer;//&SndBuf;
  for(P=GCount;P;P--,dest++,src++)
   *dest=*src;
  //c=GCount<<1;

/*
  if (Count!=0)
  {
	char ast[25]="";
	sprintf(ast,"Buffer=%ld,%ld,%ld, Count=%d\n\r",Buf[0],Buf[1],Buf[2],Count);
	FCEUD_Message(ast);//"SndBuf");
  }	
*/  
//  SetBuffer(Buf,Buffer,0/*replace_this*/, Count);
//  WaveOut(SndBuf,Buffer,Count);
//  PlayBuffer(SndBuf);
  //FillSoundBuffer(SndBuf);
}
#endif

void BlitScreenWindow(unsigned char *tXBuf, int maxline);

//void BlitScreen(unsigned char *tXBuf, int maxline) // -
void FCEUD_Update(uint8 *tXBuf, int32 *Buffer, int Count)
{
 //int vmode=1;
	if (!ScreenLoc) {FCEUD_PrintError("SCREEN = NULL !!!"); __menuet__delay100(300);}
 UpdateFCEUWindow();
 /*if(fullscreen)
  BlitScreenFull(XBuf,maxline);
 else if(!windowedfailed)*/
#ifdef SOUND
  if (inited&1)
  {
/*	 char ast[100]="";
	 int i;
	 sprintf(ast,"%d",Buffer[0]);
	 for (i=1;i<5;i++)
	 {
	   sprintf(ast,"%s,%d",ast,Buffer[i]);
	 } 
     sprintf(ast,"%s; Count = %d\n\r",ast,Count);
	 FCEUD_Message(ast);*/
     if (SetBuffer(SndBuf,Buffer,0, Count)) FCEUD_Message("error from SetBuffer \n\r");
     //else
	 //{
	    //	SndBuf = Buffer;
	    GCount = Count;
	//    WriteSoundDSP(Buffer);
  int P;
/*  int32 *src=Buffer;
  int16 *dest=Buf;//&SndBuf;
  for(P=GCount;P;P--,dest++,src++)
   *dest=*src;						
 */  
//  for(P=0;P<GCount;P++)
//    Buf[P]=Buffer[P]&0xFFFF;
//		WaveOut(SndBuf,Buf,Count);
		//WaveOut(SndBuf,Buffer,Count);
		if (PlayBuffer(SndBuf,0))
		//if (PlayBuffer(SndBuf,PLAY_SYNC)) 
		{		  
		  FCEUD_Message("error from PlayBuffer \n\r");
		  //sprintf(ast,"%s\n\r",((char*)(*(uint32*)(SndBuf))));
		  //sprintf(ast,"%ld\n\r",*((uint32*)SndBuf));
//		  sprintf(ast,"%ld\n\r", SndBuf);
//		  FCEUD_Message(ast);
		}  
	 //}
  }
#endif
 if(tXBuf)
 {
  #ifdef FRAMESKIP
  if(frameskip)
   FCEUI_FrameSkip(frameskip);
  #endif
  BlitScreenWindow(tXBuf,240);
 }

#ifdef FPS 
	char fps_st[10]="";
	static int fps=0, timer=0;
	fps++;
	if (timer+100<__kolibri__getticks())	
	{
		timer=__kolibri__getticks();
		
		sprintf(fps_st,"fps = %i",fps);
		__menuet__bar(10,25,70,15,0);
		__menuet__write_text(10,30,0xFFFFFF,fps_st,strlen(fps_st));
		fps=0;
	}
#endif	//FPS
	FCEUD_UpdateInput();
}

void BlitScreenWindow(unsigned char *tXBuf, int maxline) // +
{
	int x,y,j;
	uint32 i;
	int W=WinSizeX*256*3;
	i=0;
	for(y=maxline;y;y--)
	{
		for(x=256;x;x--)
		{
			for (j=0;j<WinSizeX;j++)
			{
				*(uint8 *)(ScreenLoc+(i*3))=paldbb[(uint8)*tXBuf];
				*(uint8 *)(ScreenLoc+(i*3+1))=paldbg[(uint8)*tXBuf];
				*(uint8 *)(ScreenLoc+(i*3+2))=paldbr[(uint8)*tXBuf];			
				i++;
			}
			tXBuf++;
		}
		tXBuf+=16;
		for (j=1;j<WinSizeY;j++)
		{
			memcpy(ScreenLoc+i*3, ScreenLoc+i*3-W, W);
			i+=256*WinSizeX;
		}	
	}
	__menuet__putimage(5,40,256*WinSizeX,240*WinSizeY,ScreenLoc);	
}

// Keyboard interface

char *GetKeyboard() // +
{
	int	j=0,i=__menuet__check_for_event();
	ProcessEvent(i);	
	if (i==2) j=__menuet__getkey();
	if (j==0) return keybuf;
	switch(j)
	{			
		//F2 pressed
		case 60:  SetWinSize();  break;
		//F3 pressed
		case 61:  LoadNESFile();  break;
		default:
			if (j>0x7F) keybuf[j&0x7F] = 0;
			else keybuf[j]=1;
		break;
	}
	return keybuf;
}

int UpdateKeyboard(void)
{	
	GetKeyboard();	
	return 1;
}

int InitKeyboard()
{
	//Init to send scancode 
	int i;
	for(i=0;i<256;i++) keybuf[i]=0;
	__kolibri__setkbmode(1);
	__kolibri__getasciimap(KeyMap);
	return 1;
}

void InitMouse()
{
	__asm__ __volatile__("int $0x40"::"a"(40),"b"(39));
}

//extern char __menuet__app_path_area[1024];
void GetBaseDirectory(void)
{

	//int x;
	//BaseDirectory[0]=0;
	sprintf(BaseDirectory,"/hd0/2");
	//__kolibri__getcurdir(BaseDirectory);
	//sprintf(BaseDirectory,"%s",__menuet__app_path_area);
	//FCEUD_Message(BaseDirectory);
	//__menuet__delay100(300);
}

void CreateDirs(void)
{
	char TempArray[2048]="";
	int  error=0;

	sprintf(TempArray,"%s/fcs",BaseDirectory);
	error=__kolibri__mkdir(TempArray);
	if (error) { sprintf(TempArray,"e_%d Can't create directory for saves",error);  FCEUD_PrintError(TempArray); return; }

	sprintf(TempArray,"%s/snaps",BaseDirectory);
	error=__kolibri__mkdir(TempArray);
	if (error) { sprintf(TempArray,"e_%d Can't create directory for snaps",error); FCEUD_PrintError(TempArray); return; }

	FCEUD_Message("Directories created\n\r");
}

void FCEUD_Message(char *s)
{
	//__menuet__bar(5,winheight-15,winwidth-10,12,0);
	//__menuet__write_text(10,winheight-15,0x000000FF,s,70);
	__kolibri__debug_out(s);
}


void FCEUD_PrintError(char *s)
{
	__menuet__bar(5,winheight-15,winwidth-10,12,0);
	__menuet__write_text(10,winheight-15,0x0000FF00,s,70);
}


int DriverInitialize(void) // +
{
#ifdef SOUND 
 //soundq=1; //ASPER delete this line.
	if((soundo=InitSound()))
	{
	 inited|=1;
	 soundo=44100;
	 //soundo=48000;
	 FCEUI_Sound(soundo);
	  if(soundq && (soundo<44100 || soundo>48000) && soundo!=96000)
	  {
	   //printf("    Sound playback rate of %d is out of the acceptable range(44100-48000, 96000) when high-quality sound is enabled.\n",soundo);
	   char ast[25]="";
	   sprintf(ast,"    Sound playback rate of %d is out of the acceptable range\n\r(44100-48000, 96000) when high-quality sound is enabled.\n\r",soundo);
	   FCEUD_Message(ast);
	   //KillSound();
	   FCEUI_Sound(0);
	   inited&=~1;
	  }
	  else FCEUD_Message(" Sound OK.\n\r");
	}
	else FCEUD_Message("Sound driver uninitialized.\n\r");
//	   char bst[25]="";
//	   sprintf(bst,"sizeof(Long Double)=%lu.\n\r",sizeof(long double));
//	   FCEUD_Message(bst);
#endif
   /*
   if(InitJoysticks())
    inited|=2;
	*/
	if(!InitVideo()) return 0;
    inited|=4;
	InitKeyboard();
    inited|=8;
	return 1;
}

void DriverKill(void)
{
  //sprintf(TempArray,"%s/fceu.cfg",BaseDirectory);
  //SaveConfig(TempArray);
  //KeyboardClose();
    //free(ScreenLoc);
  //KillVideo();
#ifdef SOUND
  if (inited&1)
  {
    StopBuffer(SndBuf);
	DestroyBuffer(SndBuf);
  }
#endif
}

void UpdateDriver(void) // +
{
	UpdateFCEUWindow();
}


extern char __menuet__app_param_area[1024];
//extern char __menuet__app_path_area[];

void app_main(void) // +
{
	paint();
	GetBaseDirectory();
	FCEUI_SetBaseDirectory(BaseDirectory);
	CreateDirs();
	/*if(argc<=1) {CheckArgs();return 1;}
	sprintf(TempArray,"%s/fceu.cfg",BaseDirectory);
	LoadConfig(TempArray);
	DoArgs(argc, argv);
	return fceumain(argv[argc-1]);
	*/
	FCEUI_Initialize();
	DriverInitialize();
	if (strlen(__menuet__app_param_area)<1) LoadNESFile();
  	else 
	{
		sprintf(FileNES,"%s",__menuet__app_param_area);
		StartGame(FileNES);
	}	
}
