// Sound interface 
#ifdef SOUND
static int soundo=1;
//typedef unsigned int SNDBUF;
typedef uint32 SNDBUF;

//#define BUFSIZE 2048
#define BUFSIZE 800
//#define BUFSIZE 256
//#define BUFSIZE 64
//byte Buf[BUFSIZE];
static int16 Buf[BUFSIZE];
SNDBUF SndBuf=777;
//SNDBUF *SndBuf=Buf;

typedef struct 
{
  __u32    handle;
  __u32    io_code;
  void     *input;
  int      inp_size;
  void     *output;
  int      out_size;
}ioctl_t;

ioctl_t ioctl;

#define SOUND_VERSION 5

#define SRV_GETVERSION      0
#define SND_CREATE_BUFF     1
#define SND_DESTROY_BUFF    2
#define SND_SETFORMAT       3
#define SND_GETFORMAT       4 
#define SND_RESET           5
#define SND_SETPOS          6
#define SND_GETPOS          7
#define SND_SETBUFF         8
#define SND_OUT             9
#define SND_PLAY           10
#define SND_STOP           11
#define SND_SETVOLUME      12
#define SND_GETVOLUME      13
#define SND_SETPAN         14
#define SND_GETPAN         15
#define SND_GETBUFFSIZE    16

#define PCM_ALL       0

#define PCM_OUT       0x08000000
#define PCM_RING      0x10000000
#define PCM_STATIC    0x20000000
#define PCM_FLOAT     0x40000000
#define PCM_FILTER    0x80000000

#define PCM_2_16_48   1
#define PCM_1_16_48   2
#define PCM_2_16_44   3
#define PCM_1_16_44   4
#define PCM_2_16_32   5
#define PCM_1_16_32   6
#define PCM_2_16_24   7
#define PCM_1_16_24   8
#define PCM_2_16_22   9
#define PCM_1_16_22  10
#define PCM_2_16_16  11
#define PCM_1_16_16  12
#define PCM_2_16_12  13
#define PCM_1_16_12  14
#define PCM_2_16_11  15
#define PCM_1_16_11  16
#define PCM_2_16_8   17
#define PCM_1_16_8   18
#define PCM_2_8_48   19
#define PCM_1_8_48   20
#define PCM_2_8_44   21
#define PCM_1_8_44   22
#define PCM_2_8_32   23
#define PCM_1_8_32   24
#define PCM_2_8_24   25
#define PCM_1_8_24   26
#define PCM_2_8_22   27
#define PCM_1_8_22   28
#define PCM_2_8_16   29
#define PCM_1_8_16   30
#define PCM_2_8_12   31
#define PCM_1_8_12   32
#define PCM_2_8_11   33
#define PCM_1_8_11   34
#define PCM_2_8_8    35
#define PCM_1_8_8    36

#define PLAY_SYNC     0x80000000

  char szInfinity[9]="INFINITY\0",
       szSound[6]="SOUND\0";
  static __u32 hSound=0, hrdwSound=0;


int CreateBuffer(unsigned int format,int size,SNDBUF *buf)
{
  struct 
  {
    __u32    fmt;
    __u32    size;
  } CB_in;
  CB_in.fmt=format;
  CB_in.size=size;

  ioctl.handle=hSound;
  ioctl.io_code=SND_CREATE_BUFF;
  ioctl.input=&CB_in;
  ioctl.inp_size=8;
  *(SNDBUF*)ioctl.output=buf;
  ioctl.out_size=4;
/*
  if (__kolibri__manage_driver(&ioctl))
  { 
    FCEUD_Message("CreateBuffer error!\n\r");
  }
		  char ast[50];
		  sprintf(ast,"SndBuf1=%lX\n\r", SndBuf);		  
		  FCEUD_Message(ast);
*/
  return __kolibri__manage_driver(&ioctl);  
}

void SetVolume(SNDBUF hBuff, int left_volume, int right_volume)
{
  struct
  {
    __u32    buf;
    __u32    lvol;
    __u32    rvol;
  } CB_in;
  CB_in.buf=hBuff;
  CB_in.lvol=left_volume;
  CB_in.rvol=right_volume;

  ioctl.handle=hSound;
  ioctl.io_code=SND_SETVOLUME;
  ioctl.input=&CB_in;
  ioctl.inp_size=12;
  *(__u32*)ioctl.output=0;
  ioctl.out_size=0;
  __kolibri__manage_driver(&ioctl);
}

int GetVolume(SNDBUF hBuff, int *left_volume, int *right_volume)
{
  struct
  {
    __u32    lvol;
    __u32    rvol;
  } CB_out;
  CB_out.lvol=left_volume;
  CB_out.rvol=right_volume;

  ioctl.handle=hSound;
  ioctl.io_code=SND_GETVOLUME;
  *(__u32*)ioctl.input=hBuff;
  ioctl.inp_size=4;
  ioctl.output=&CB_out;
  ioctl.out_size=8;
  return __kolibri__manage_driver(&ioctl);
}

/*
void TrashSound(void)
{
}
*/
int InitSound(void)
{
//  __u32 version=555;
  
  hSound=__kolibri__load_driver(szInfinity);
  if (!hSound) return 0;
  hrdwSound=__kolibri__load_driver(szSound);
  
/*  
  ioctl.handle=hSound;
  ioctl.io_code=SND_GETVERSION;
  ioctl.input=0;
  ioctl.inp_size=0;
  *(__u32*)ioctl.output=&version;
  ioctl.out_size=4;
  __kolibri__manage_driver(&ioctl);
		  char ast[50];
		  sprintf(ast,"Addr=%lX ; Versus=%lX\n\r", ioctl.output, version);//*(__u32*)ioctl.output);		  
		  FCEUD_Message(ast);
 */ 
   //if (CreateBuffer(PCM_2_16_44|PCM_STATIC, BUFSIZE, &SndBuf)) //Create static buffer
   //if (CreateBuffer(PCM_1_8_44, 0, &SndBuf)) //Create stream buffer
   //if (CreateBuffer(PCM_1_16_44, 0, &SndBuf)) //Create stream buffer
   //if (CreateBuffer(PCM_1_8_48, 0, &SndBuf)) //Create stream buffer
   if (CreateBuffer(PCM_2_16_11|PCM_RING, 0, &SndBuf)) //Create stream buffer
   {
     __kolibri__debug_str("create buffer return error\n\r");
     return 0;
   }
   int l=-700, r=-700; //-7 db
   SetVolume(SndBuf,l,r);
/*
   l=0; r=0;
   if (GetVolume(SndBuf,&l,&r))
   {
     __kolibri__debug_str("GetVolume return error\n\r");
     return 0;
   }
		  sprintf(ast,"Left=%d ; Right=%d\n\r", l, r);//*(__u32*)ioctl.output);		  
		  FCEUD_Message(ast);
  */  
 
  return 1;
}

int PlayBuffer(SNDBUF hBuff, unsigned int flags)
{
  struct 
  {
    __u32    buf;
    __u32    flags;
  } CB_in;
  CB_in.buf=hBuff;
  CB_in.flags=flags;//PLAY_SYNC;//0;

  ioctl.handle=hSound;
  ioctl.io_code=SND_PLAY;
  ioctl.input=&CB_in;
  ioctl.inp_size=8;
  *(__u32*)ioctl.output=0;
  ioctl.out_size=0;
  return __kolibri__manage_driver(&ioctl);
}

int SetBuffer(SNDBUF hBuff,void* buff,int offs, int size)
{
  struct 
  {
    __u32    buf;
    __u32    src_buf;
	__u32    offset;
	__u32    size;
  } CB_in;
  CB_in.buf=hBuff;
  CB_in.src_buf=buff;
  CB_in.offset=offs;  
  CB_in.size=size;

  ioctl.handle=hSound;
  ioctl.io_code=SND_SETBUFF;
  ioctl.input=&CB_in;
  ioctl.inp_size=16;
  *(__u32*)ioctl.output=0;
  ioctl.out_size=0;
  return __kolibri__manage_driver(&ioctl);
}

int WaveOut(SNDBUF hBuff,void *buff, int size)
{
  struct 
  {
    __u32    buf;
    __u32    src_buf;
    __u32    size;
  } CB_in;
  CB_in.buf=hBuff;
  CB_in.src_buf=buff;
  CB_in.size=size;

  ioctl.handle=hSound;
  ioctl.io_code=SND_OUT;
  ioctl.input=&CB_in;
  ioctl.inp_size=12;
  *(__u32*)ioctl.output=0;
  ioctl.out_size=0;
  return __kolibri__manage_driver(&ioctl);
}

int StopBuffer(SNDBUF hBuff)
{
  ioctl.handle=hSound;
  ioctl.io_code=SND_STOP;
  *(__u32*)ioctl.input=hBuff;
  ioctl.inp_size=4;
  *(SNDBUF*)ioctl.output=0;
  ioctl.out_size=0;
  return __kolibri__manage_driver(&ioctl);
}

int DestroyBuffer(SNDBUF hBuff)
{
  ioctl.handle=hSound;
  ioctl.io_code=SND_DESTROY_BUFF;
  *(__u32*)ioctl.input=hBuff;
  ioctl.inp_size=4;
  *(SNDBUF*)ioctl.output=0;
  ioctl.out_size=0;
  return __kolibri__manage_driver(&ioctl);
}

/*
static void __dsploop(void)
{
   waitsigs=1;
   for(;;)
   {
     FillSoundBuffer(Buf);
     if((vmode==3 || vmode==6) || sasync)
       {
        ZL+=ZK;
        if(ZL>=0x2000000)
        {
          ZL-=0x2000000;
          if(vretrace<4) vretrace++;
        }
       }
       write(dspfd,Buf,256);
   }
}
*/

//__________________________________________________________________
/*

#define DEV_PLAY        1
#define DEV_STOP        2
#define DEV_CALLBACK    3

void SetDevCallback(uint32 *addr)
{
  ioctl.handle=hrdwSound;
  ioctl.io_code=DEV_CALLBACK;
  ioctl.input=addr;
  ioctl.inp_size=4;
  ioctl.output=0;
  ioctl.out_size=0;
  __kolibri__manage_driver(&ioctl);
}

int DevPlay()
{
  ioctl.handle=hrdwSound;
  ioctl.io_code=DEV_PLAY;
  ioctl.input=0;
  ioctl.inp_size=0;
  ioctl.output=0;
  ioctl.out_size=0;
  __kolibri__manage_driver(&ioctl);
}
*/
#endif /*SOUND*/
